//
// PC-8801 Keyboard G~[^ for Windows
//
//             copyleft 2009 Koichi Nishida
//            on Gnu General Public License
//

#include <stdio.h>
#include <windows.h>
#include <tchar.h>
#include "stdafx.h"
#include "ftd2xx.h"
#include "resource.h"

// Windows ̃L[R[hA88 ̃L[R[hւ̃}bv
unsigned char keytable[256] = {
/*            0    1    2    3    4    5    6    7    8    9    a    b    c    d    e    f */
/* 0x00 */ 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x38,0x0a,0xff,0xff,0xff,0x71,0xff,0xff,
/* 0x10 */ 0x68,0x78,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x79,0xff,0xff,0xff,0xff,
/* 0x20 */ 0x69,0x0b,0x1b,0x09,0x08,0x2a,0x18,0x28,0x1a,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
/* 0x30 */ 0x06,0x16,0x26,0x36,0x46,0x56,0x66,0x76,0x07,0x17,0xff,0xff,0xff,0xff,0xff,0xff,
/* 0x40 */ 0xff,0x12,0x22,0x32,0x42,0x52,0x62,0x72,0x03,0x13,0x23,0x33,0x43,0x53,0x63,0x73,
/* 0x50 */ 0x04,0x14,0x24,0x34,0x44,0x54,0x64,0x74,0x05,0x15,0x25,0xff,0xff,0xff,0xff,0xff,
/* 0x60 */ 0x00,0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x01,0x11,0x21,0x31,0x51,0x5a,0x61,0x6a,
/* 0x70 */ 0x19,0x29,0x39,0x49,0x59,0x7a,0x58,0x48,0x4a,0xff,0x3a,0xff,0xff,0xff,0xff,0xff,
/* 0x80 */ 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
/* 0x90 */ 0xff,0xff,0x41,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
/* 0xa0 */ 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
/* 0xb0 */ 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x27,0x37,0x47,0x75,0x57,0x67,
/* 0xc0 */ 0x02,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
/* 0xd0 */ 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x35,0x45,0x55,0x65,0x77,
/* 0xe0 */ 0xff,0xff,0x77,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
/* 0xf0 */ 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

// CAPS & Jȉ
int CapsState, KanaState;

// eL[ƂĎg
int ArrowAsTen;

// USB nh
FT_HANDLE ftHandle;

// vg^Cv錾
int InitUSB();
void TrashUSB();
int PutUSB(BYTE);
LRESULT CALLBACK MyDlgProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
unsigned char lookupKey(unsigned char keyCode);

// C
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int showCmd)
{
	MSG msg;
    HWND hDlg = CreateDialog(hInst, "MYDLG", NULL, (DLGPROC)MyDlgProc);
	unsigned char dt;
	int wp;

    while(GetMessage(&msg, NULL, 0, 0)) {
		wp = (int)msg.wParam;
		// L[͂́A_CAOvV[Wł͕߂܂Ȃ悤łBBB
		switch (msg.message) {
		case WM_KEYDOWN:				// L[ꂽƂ
			switch (wp) {
			case VK_F6:
				if (PutUSB((CapsState ? 0x80 : 0x0) | 0x7a)) DestroyWindow(hDlg);
				CapsState = !CapsState;
				continue;
			case VK_F7:
				if (PutUSB((KanaState ? 0x80 : 0x0) | 0x58)) DestroyWindow(hDlg);
				KanaState = !KanaState;
				continue;
			default:
				if ((dt = lookupKey((unsigned char)wp)) != 0xff) {
					if (PutUSB(dt)) DestroyWindow(hDlg);
					continue;
				}
			}
			break;
		case WM_KEYUP:					// L[ꂽƂ
			switch (wp) {
			case VK_F6: continue;
			case VK_F7: continue;
			default:
				if ((dt = lookupKey((unsigned char)wp)) != 0xff) {
					if (PutUSB(0x80 | dt)) DestroyWindow(hDlg);
					continue;
				}
			}
			break;
	
		}
        if (hDlg == 0 || !IsDialogMessage(hDlg, &msg)) {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }
	return 0;
}

// Windows ̃L[R[h 88 ̃L[R[h𓾂
unsigned char lookupKey(unsigned char keyCode)
{
	if (ArrowAsTen) {
		switch (keyCode) {
		case VK_LEFT:	return 0x40;
		case VK_RIGHT:	return 0x60;
		case VK_UP:		return 0x01;
		case VK_DOWN:	return 0x20;
		default: return keytable[keyCode];
		}
	} else return keytable[keyCode];
}

// _CAOvV[W
LRESULT CALLBACK MyDlgProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static HMENU hmenu;				// j[

	switch (msg) {
	case WM_INITDIALOG:
		CapsState = KanaState = 0;
		ArrowAsTen = 0;

		hmenu = LoadMenu(NULL, _T("IDR_MENU"));
		SetMenu(hwnd, hmenu);
		CheckMenuItem(hmenu, ID_ARROW, ArrowAsTen ? MF_CHECKED : MF_UNCHECKED);
		DrawMenuBar(hwnd);

		// USB 
		if (InitUSB()) {
			MessageBox(NULL, _T("USB ̏Ɏs܂"), _T("G["), MB_OK);
			DestroyWindow(hwnd);
			return TRUE;
		}
		// L[Xe[g
		if (PutUSB(0xff)) {
			DestroyWindow(hwnd);
			return TRUE;
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case ID_EXIT:
			DestroyWindow(hwnd);
			return TRUE;
		case ID_ARROW:
			ArrowAsTen = !ArrowAsTen;
			CheckMenuItem(hmenu, ID_ARROW, ArrowAsTen ? MF_CHECKED : MF_UNCHECKED);
			return TRUE;
		}
		break;
	case WM_CLOSE:
		DestroyWindow(hwnd);
		return TRUE;
	case WM_DESTROY:
		DestroyMenu(hmenu);
		hmenu = NULL;
		TrashUSB();
		PostQuitMessage(0);
		return TRUE;
	}
	return FALSE;
}

// USB 
int InitUSB()
{
	FT_STATUS ftStatus;
	
	// USB I[v
	ftStatus = FT_OpenEx("88 KEYBOARD EMULATOR", FT_OPEN_BY_DESCRIPTION, &ftHandle);
	if (ftStatus != FT_OK) return 1;

	ftStatus = FT_SetLatencyTimer(ftHandle, 2);
	if (ftStatus != FT_OK) return 1;

	// Output mode ݒ
	ftStatus = FT_SetBitMode(ftHandle, 0x00, 0x00);
	if (ftStatus != FT_OK) return 1;

	// {[[g ݒ
	ftStatus = FT_SetBaudRate(ftHandle, FT_BAUD_19200);
	if (ftStatus != FT_OK) return 1;

	// f[^ ݒ
	ftStatus = FT_SetDataCharacteristics(ftHandle, FT_BITS_8, FT_STOP_BITS_2, FT_PARITY_NONE);
	if (ftStatus != FT_OK) return 1;
	
	// Time Out ݒ
	ftStatus = FT_SetTimeouts(ftHandle, 3000, 3000);
	if (ftStatus != FT_OK) return 1;

	return 0;
}

// USB N[Y
void TrashUSB()
{
	FT_Close(ftHandle);
}

// USB wf[^𑗂
int PutUSB(BYTE dt)
{
	unsigned char buff[1];
	unsigned long written = 0;
	FT_STATUS ftStatus;

	buff[0] = dt;
	ftStatus = FT_Write(ftHandle, buff, 1, &written);
	if (written == 0 || ftStatus != FT_OK) {
		if (FT_ResetPort(ftHandle) != FT_OK) {
			if (FT_CyclePort(ftHandle) != FT_OK) {
				return 1;
			}
			if (InitUSB()) return 1;
		}
	}
	return 0;
}
